OSDN Git Service

Fix bad S_IS* macros in <sys/stat.h> on m88k-sysv3.
[pf3gnuchains/gcc-fork.git] / gcc / fixincludes
1 #! /bin/sh
2 # Install modified versions of certain ANSI-incompatible system header files
3 # which are fixed to work correctly with ANSI C
4 # and placed in a directory that GNU C will search.
5
6 # See README-fixinc for more information.
7
8 # Command to run gcc.
9 GCCCMD=${4-${GCCCMD-gcc}}
10
11 # Directory where gcc sources (and sometimes special include files) live.
12 # fixincludes doesn't use this, but fixinc.svr4 does, and I want to make
13 # sure somebody doesn't try to use arg3 for something incompatible. -- gumby
14 SRCDIR=${3-${SRCDIR-.}}
15
16 # Directory containing the original header files.
17 # (This was named INCLUDES, but that conflicts with a name in Makefile.in.)
18 INPUT=${2-${INPUT-/usr/include}}
19
20 # Directory in which to store the results.
21 LIB=${1?"fixincludes: output directory not specified"}
22
23 # Define PWDCMD as a command to use to get the working dir
24 # in the form that we want.
25 PWDCMD=pwd
26 case "`pwd`" in
27 //*)
28         # On an Apollo, discard everything before `/usr'.
29         PWDCMD="eval pwd | sed -e 's,.*/usr/,/usr/,'"
30         ;;
31 esac
32
33 # Original directory.
34 ORIGDIR=`${PWDCMD}`
35
36 # Make sure it exists.
37 if [ ! -d $LIB ]; then
38   mkdir $LIB || exit 1
39 fi
40
41 # Make LIB absolute only if needed to avoid problems with the amd.
42 case $LIB in
43 /*)
44         ;;
45 *)
46         cd $LIB; LIB=`${PWDCMD}`
47         ;;
48 esac
49
50 # Make SRCDIR absolute only if needed to avoid problems with the amd.
51 cd $ORIGDIR
52 case $SRCDIR in
53 /*)
54         ;;
55 *)
56         cd $SRCDIR; SRCDIR=`${PWDCMD}`
57         ;;
58 esac
59
60 # Fail if no arg to specify a directory for the output.
61 if [ x$1 = x ]
62 then echo fixincludes: no output directory specified
63 exit 1
64 fi
65
66 echo Building fixed headers in ${LIB}
67
68 # Determine whether this system has symbolic links.
69 if ln -s X $LIB/ShouldNotExist 2>/dev/null; then
70   rm -f $LIB/ShouldNotExist
71   LINKS=true
72 elif ln -s X /tmp/ShouldNotExist 2>/dev/null; then
73   rm -f /tmp/ShouldNotExist
74   LINKS=true
75 else
76   LINKS=false
77 fi
78
79 echo Finding directories and links to directories
80 cd ${INPUT}
81 # Find all directories and all symlinks that point to directories.
82 # Put the list in $files.
83 # Each time we find a symlink, add it to newdirs
84 # so that we do another find within the dir the link points to.
85 # Note that $files may have duplicates in it;
86 # later parts of this file are supposed to ignore them.
87 dirs="."
88 levels=2
89 while [ -n "$dirs" ] && [ $levels -gt 0 ]
90 do
91     levels=`expr $levels - 1`
92     newdirs=
93     for d in $dirs
94     do
95         echo " Searching $INPUT/$d"
96         if [ "$d" != . ]
97         then
98             d=$d/.
99         fi
100
101         # Find all directories under $d, relative to $d, excluding $d itself.
102         files="$files `find $d -type d -print | \
103                        sed -e '/\/\.$/d' -e '/^\.$/d'`"
104         # Find all links to directories.
105         # Using `-exec test -d' in find fails on some systems,
106         # and trying to run test via sh fails on others,
107         # so this is the simplest alternative left.
108         # First find all the links, then test each one.
109         theselinks=
110         $LINKS && \
111           theselinks=`find $d -type l -print`
112         for d1 in $theselinks --dummy--
113         do
114             # If the link points to a directory,
115             # add that dir to $newdirs
116             if [ -d $d1 ]
117             then
118                 newdirs="$newdirs $d1"
119             fi
120         done
121     done
122
123     files="$files $newdirs"
124     dirs="$newdirs"
125 done
126
127 dirs=
128 echo "All directories (including links to directories):"
129 echo $files
130
131 for file in $files; do
132   rm -rf $LIB/$file
133   if [ ! -d $LIB/$file ]
134   then mkdir $LIB/$file
135   fi
136 done
137 mkdir $LIB/root
138
139 # treetops gets an alternating list
140 # of old directories to copy
141 # and the new directories to copy to.
142 treetops="${INPUT} ${LIB}"
143
144 if $LINKS; then
145   echo 'Making symbolic directory links'
146   for file in $files; do
147     dest=`ls -ld $file | sed -n 's/.*-> //p'`
148     if [ "$dest" ]; then    
149       cwd=`${PWDCMD}`
150       # In case $dest is relative, get to $file's dir first.
151       cd ${INPUT}
152       cd `echo ./$file | sed -n 's&[^/]*$&&p'`
153       # Check that the target directory exists.
154       # Redirections changed to avoid bug in sh on Ultrix.
155       (cd $dest) > /dev/null 2>&1
156       if [ $? = 0 ]; then
157         cd $dest
158         # X gets the dir that the link actually leads to.
159         x=`${PWDCMD}`
160         # If a link points to ., make a similar link to .
161         if [ $x = $INPUT ]; then
162           echo $file '->' . ': Making link'
163           rm -fr ${LIB}/$file > /dev/null 2>&1
164           ln -s . ${LIB}/$file > /dev/null 2>&1
165         # If link leads back into ${INPUT},
166         # make a similar link here.
167         elif expr $x : "${INPUT}/.*" > /dev/null; then
168           # Y gets the actual target dir name, relative to ${INPUT}.
169           y=`echo $x | sed -n "s&${INPUT}/&&p"`
170           # DOTS is the relative path from ${LIB}/$file's dir back to ${LIB}.
171           dots=`echo "$file" |
172                 sed -e 's@^./@@' -e 's@[^/][^/]*@..@g' -e 's@..$@@'`
173           echo $file '->' $dots$y ': Making link'
174           rm -fr ${LIB}/$file > /dev/null 2>&1
175           ln -s $dots$y ${LIB}/$file > /dev/null 2>&1
176         else
177           # If the link is to a dir $target outside ${INPUT},
178           # repoint the link at ${INPUT}/root$target
179           # and process $target into ${INPUT}/root$target
180           # treat this directory as if it actually contained the files.
181           echo $file '->' root$x ': Making link'
182           if [ -d $LIB/root$x ]
183           then true
184           else
185             dirname=root$x/
186             dirmade=.
187             cd $LIB
188             while [ x$dirname != x ]; do
189               component=`echo $dirname | sed -e 's|/.*$||'`
190               mkdir $component >/dev/null 2>&1
191               cd $component
192               dirmade=$dirmade/$component
193               dirname=`echo $dirname | sed -e 's|[^/]*/||'`
194             done
195           fi
196           # Duplicate directory structure created in ${LIB}/$file in new
197           # root area.
198           for file2 in $files; do
199             case $file2 in
200               $file/./*)
201                 dupdir=${LIB}/root$x/`echo $file2 | sed -n "s|^${file}/||p"`
202                 echo "Duplicating ${file}'s ${dupdir}"
203                 if [ -d ${dupdir} ]
204                 then true
205                 else
206                   mkdir ${dupdir}
207                 fi
208                 ;;
209               *)
210                 ;;
211             esac
212           done
213           # DOTS is the relative path from ${LIB}/$file's dir back to ${LIB}.
214           dots=`echo "$file" |
215                 sed -e 's@^./@@' -e 's@[^/][^/]*@..@g' -e 's@..$@@'`
216           rm -fr ${LIB}/$file > /dev/null 2>&1
217           ln -s ${dots}root$x ${LIB}/$file > /dev/null 2>&1
218           treetops="$treetops $x ${LIB}/root$x"
219         fi
220       fi
221       cd $cwd
222     fi
223   done
224 fi
225
226 required=
227 set x $treetops
228 shift
229 while [ $# != 0 ]; do
230   # $1 is an old directory to copy, and $2 is the new directory to copy to.
231   cd ${INPUT}
232   cd $1
233 # The same dir can appear more than once in treetops.
234 # There's no need to scan it more than once.
235   if [ -f $2/DONE ]
236   then
237     files=
238   else
239     touch $2/DONE
240     echo Fixing directory $1 into $2
241 # Check .h files which are symlinks as well as those which are files.
242 # A link to a header file will not be processed by anything but this.
243     if $LINKS; then
244       files=`find . -name '*.h' \( -type f -o -type l \) -print`
245     else
246       files=`find . -name '*.h' -type f -print`
247     fi
248     echo Checking header files
249   fi
250 # Note that BSD43_* are used on recent MIPS systems.
251   for file in $files; do
252 # This call to egrep is essential, since checking a file with egrep
253 # is much faster than actually trying to fix it.
254 # It is also essential that most files *not* match!
255 # Thus, matching every #endif is unacceptable.
256 # But the argument to egrep must be kept small, or many versions of egrep
257 # won't be able to handle it.
258 #
259 # We use the pattern [!-.0-~] instead of [^/    ] to match a noncomment
260 # following #else or #endif because some buggy egreps think [^/] matches
261 # newline, and they thus think `#else ' matches `#e[ndiflse]*[  ]+[^/   ]'.
262 #
263 # We use the pattern [^a-zA-Z0-9_][_a-ce-km-z][a-z0-9] to match an identifier
264 # following #if or #elif that is not surrounded by __.  The `a-ce-km-z'
265 # in this pattern lacks `d' and `l'; this means we don't worry about
266 # identifiers starting with `d' or `l'.  This is OK, since none of the
267 # identifiers below start with `d' or `l'.  It also greatly improves
268 # performance, since many files contain lines of the form `#if ... defined ...'
269 # or `#if lint'.
270     if egrep '//|[      _]_IO|CTRL|^#define.NULL|^#e[nl][ds][ief]*[     ]+[!-.0-~]|^#[el]*if.*[^a-zA-Z0-9_][_a-ce-km-z][a-z0-9]' $file >/dev/null; then
271       if [ -r $file ]; then
272         cp $file $2/$file >/dev/null 2>&1       \
273         || echo "Can't copy $file"
274         chmod +w $2/$file
275         chmod a+r $2/$file
276         # Here is how the sed commands in braces work.
277         # (It doesn't work to put the comments inside the sed commands.)
278                 # Surround each word with spaces, to simplify matching below.
279                 # ANSIfy each pre-ANSI machine-dependent symbol
280                 # by surrounding it with __ __.
281                 # Remove the spaces that we inserted around each word.
282         sed -e '
283                                    :loop
284           /\\$/                 N
285           /\\$/                 b loop
286           s%^\([        ]*#[    ]*else\)[       ]*/[^*].*%\1%
287           s%^\([        ]*#[    ]*else\)[       ]*[^/   ].*%\1%
288           s%^\([        ]*#[    ]*endif\)[      ]*/[^*].*%\1%
289           s%^\([        ]*#[    ]*endif\)[      ]*\*[^/].*%\1%
290           s%^\([        ]*#[    ]*endif\)[      ]*[^/*  ].*%\1%
291           /\/\/[^*]/                    s|//\(.*\)$|/*\1*/|
292           /[    ]_IO[A-Z]*[     ]*(/    s/\(_IO[A-Z]*[  ]*(\)\(.\),/\1'\''\2'\'',/
293           /[    ]BSD43__IO[A-Z]*[       ]*(/    s/(\(.\),/('\''\1'\'',/
294           /#define._IO/                 s/'\''\([cgxt]\)'\''/\1/g
295           /#define.BSD43__IO/           s/'\''\([cgx]\)'\''/\1/g
296           /[^A-Z0-9_]CTRL[      ]*(/            s/\([^'\'']\))/'\''\1'\'')/
297           /[^A-Z0-9]_CTRL[      ]*(/            s/\([^'\'']\))/'\''\1'\'')/
298           /#define[     ]*[     ]CTRL/          s/'\''\([cgx]\)'\''/\1/g
299           /#define[     ]*[     ]_CTRL/         s/'\''\([cgx]\)'\''/\1/g
300           /#define.BSD43_CTRL/          s/'\''\([cgx]\)'\''/\1/g
301           /#[el]*if/{
302                 s/[a-zA-Z0-9_][a-zA-Z0-9_]*/ & /g
303
304                 s/ bsd4\([0-9]\) / __bsd4\1__ /g
305                 s/ _*i386 / __i386__ /g
306                 s/ is68k / __is68k__ /g
307                 s/ m68k / __m68k__ /g
308                 s/ mc680\([0-9]\)0 / __mc680\10__ /g
309                 s/ news\([0-9]*\) / __news\1__ /g
310                 s/ ns32000 / __ns32000__ /g
311                 s/ pyr / __pyr__ /g
312                 s/ sony_news / __sony_news__ /g
313                 s/ sparc / __sparc__ /g
314                 s/ sun\([a-z0-9]*\) / __sun\1__ /g
315                 s/ unix / __unix__ /g
316                 s/ vax / __vax__ /g
317
318                 s/ \([a-zA-Z0-9_][a-zA-Z0-9_]*\) /\1/g
319           }
320           /^#define.NULL[       ]/      i\
321                 #undef NULL
322         ' $2/$file > $2/$file.
323         mv $2/$file. $2/$file
324         if cmp $file $2/$file >/dev/null 2>&1; then
325            rm $2/$file
326         else
327            echo Fixed $file
328            # Find any include directives that use "file".
329            for include in `egrep '^[    ]*#[    ]*include[      ]*"[^/]' $2/$file | sed -e 's/^[        ]*#[    ]*include[      ]*"\([^"]*\)".*$/\1/'`; do
330               dir=`echo $file | sed -e s'|/[^/]*$||'`
331               required="$required $1 $dir/$include $2/$dir/$include"
332            done
333         fi
334       fi
335     fi
336   done
337   shift; shift
338 done
339
340 # Make sure that any include files referenced using double quotes
341 # exist in the fixed directory.
342 set x $required
343 shift
344 while [ $# != 0 ]; do
345   # $1 is the directory to copy from, $2 is the unfixed file,
346   # $3 is the fixed file name.
347   cd ${INPUT}
348   cd $1
349   if [ -r $2 ] && [ ! -r $3 ]; then
350     cp $2 $3 >/dev/null 2>&1 || echo "Can't copy $2"
351     chmod +w $3 2>/dev/null
352     chmod a+r $3 2>/dev/null
353     echo Copied $2
354   fi
355   shift; shift; shift
356 done
357
358 cd ${INPUT}
359
360 # Install the proper definition of size_t in header files that it comes from.
361 for file in sys/types.h stdlib.h sys/stdtypes.h; do
362   if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
363     cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
364     chmod +w ${LIB}/$file 2>/dev/null
365     chmod a+r ${LIB}/$file 2>/dev/null
366   fi
367
368   if [ -r ${LIB}/$file ]; then
369     echo Fixing $file comment
370     # Get the definition of __SIZE_TYPE__, if any.
371     # (This file must be called something.c).
372     echo "__SIZE_TYPE__" > ${LIB}/types.c
373     foo=`${GCCCMD} -E -P ${LIB}/types.c`
374     rm -f ${LIB}/types.c
375     # Default to our preferred type.
376     if [ "$foo" = __SIZE_TYPE__ ]; then foo="unsigned long int"; fi
377     sed -e "s/typedef[  a-z_]*[         ]size_t/typedef $foo size_t/" ${LIB}/$file > ${LIB}/${file}.sed
378     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
379     if cmp $file ${LIB}/$file >/dev/null 2>&1; then
380       rm ${LIB}/$file
381     fi
382   fi
383 done
384
385 # Fix one other error in this file: a mismatched quote not inside a C comment.
386 file=sundev/vuid_event.h
387 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
388   mkdir ${LIB}/sundev 2>/dev/null
389   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
390   chmod +w ${LIB}/$file 2>/dev/null
391   chmod a+r ${LIB}/$file 2>/dev/null
392 fi
393
394 if [ -r ${LIB}/$file ]; then
395   echo Fixing $file comment
396   sed -e "s/doesn't/does not/" ${LIB}/$file > ${LIB}/${file}.sed
397   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
398   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
399     rm ${LIB}/$file
400   fi
401 fi
402
403 # Fix these Sun OS files to avoid an invalid identifier in an #ifdef.
404 file=sunwindow/win_cursor.h
405 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
406 #  mkdir ${LIB}/sunwindow 2>/dev/null
407   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
408   chmod +w ${LIB}/$file 2>/dev/null
409 fi
410 if [ -r ${LIB}/$file ]; then
411   echo Fixing $file
412   sed -e "s/ecd.cursor/ecd_cursor/" ${LIB}/$file > ${LIB}/${file}.sed
413   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
414   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
415     rm ${LIB}/$file
416   fi
417 fi
418 file=sunwindow/win_lock.h
419 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
420 #  mkdir ${LIB}/sunwindow 2>/dev/null
421   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
422   chmod +w ${LIB}/$file 2>/dev/null
423 fi
424 if [ -r ${LIB}/$file ]; then
425   echo Fixing $file
426   sed -e "s/ecd.cursor/ecd_cursor/" ${LIB}/$file > ${LIB}/${file}.sed
427   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
428   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
429     rm ${LIB}/$file
430   fi
431 fi
432
433 # Fix this Sun file to avoid interfering with stddef.h.
434 file=sys/stdtypes.h
435 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
436   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
437   chmod +w ${LIB}/$file 2>/dev/null
438   chmod a+r ${LIB}/$file 2>/dev/null
439 fi
440
441 if [ -r ${LIB}/$file ]; then
442   echo Fixing $file
443 sed -e '/[       ]size_t.*;/i\
444 #ifndef _GCC_SIZE_T\
445 #define _GCC_SIZE_T' \
446     -e '/[       ]size_t.*;/a\
447 #endif' \
448     -e '/[       ]ptrdiff_t.*;/i\
449 #ifndef _GCC_PTRDIFF_T\
450 #define _GCC_PTRDIFF_T' \
451     -e '/[       ]ptrdiff_t.*;/a\
452 #endif' \
453     -e '/[       ]wchar_t.*;/i\
454 #ifndef _GCC_WCHAR_T\
455 #define _GCC_WCHAR_T' \
456     -e '/[       ]wchar_t.*;/a\
457 #endif' ${LIB}/$file > ${LIB}/${file}.sed
458   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
459   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
460     rm ${LIB}/$file
461   fi
462 fi
463
464 # Fix this ARM/RISCiX file to avoid interfering with the use of __wchar_t
465 # in cc1plus.
466 file=stdlib.h
467 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
468   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
469   chmod +w ${LIB}/$file 2>/dev/null
470   chmod a+r ${LIB}/$file 2>/dev/null
471 fi
472
473 if [ -r ${LIB}/$file ]; then
474   echo Fixing $file
475   sed -e "s/\(#[        ]*ifndef[       ]*\)__wchar_t/\1_GCC_WCHAR_T/" \
476       -e "s/\(#[        ]*define[       ]*\)__wchar_t/\1_GCC_WCHAR_T/" \
477      ${LIB}/$file > ${LIB}/${file}.sed
478   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
479   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
480     rm ${LIB}/$file
481   fi
482 fi
483
484 # Fix this file to avoid interfering with stddef.h, but don't mistakenly
485 # match e.g. ssize_t present in AIX for the ps/2.
486 file=sys/types.h
487 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
488   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
489   chmod +w ${LIB}/$file 2>/dev/null
490   chmod a+r ${LIB}/$file 2>/dev/null
491 fi
492
493 if [ -r ${LIB}/$file ]; then
494   echo Fixing $file
495 sed -e '/[      ]size_t.*;/i\
496 #ifndef _GCC_SIZE_T\
497 #define _GCC_SIZE_T' \
498     -e '/[      ]size_t.*;/a\
499 #endif' ${LIB}/$file > ${LIB}/${file}.sed
500   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
501   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
502     rm ${LIB}/$file
503   fi
504 fi
505
506 # Fix HP's use of ../machine/inline.h to refer to
507 # /usr/include/machine/inline.h
508 file=sys/spinlock.h
509 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
510   cp $file ${LIB}/$file
511 fi
512 if [ -r ${LIB}/$file ] ; then
513   echo Fixing $file
514   sed -e 's,"../machine/inline.h",<machine/inline.h>,' \
515     -e 's,"../machine/psl.h",<machine/psl.h>,' \
516   ${LIB}/$file > ${LIB}/${file}.sed
517   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
518   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
519     rm ${LIB}/$file
520   fi
521 fi
522
523 # Fix an error in this file: the #if says _cplusplus, not the double
524 # underscore __cplusplus that it should be
525 file=tinfo.h
526 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
527   mkdir ${LIB}/rpcsvc 2>/dev/null
528   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
529   chmod +w ${LIB}/$file 2>/dev/null
530   chmod a+r ${LIB}/$file 2>/dev/null
531 fi
532
533 if [ -r ${LIB}/$file ]; then
534   echo Fixing $file, __cplusplus macro
535   sed -e 's/[   ]_cplusplus/ __cplusplus/' ${LIB}/$file > ${LIB}/${file}.sed
536   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
537   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
538     rm ${LIB}/$file
539   fi
540 fi
541
542 # Fix an error in this file: a missing semi-colon at the end of the statsswtch
543 # structure definition.
544 file=rpcsvc/rstat.h
545 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
546   mkdir ${LIB}/rpcsvc 2>/dev/null
547   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
548   chmod +w ${LIB}/$file 2>/dev/null
549   chmod a+r ${LIB}/$file 2>/dev/null
550 fi
551
552 if [ -r ${LIB}/$file ]; then
553   echo Fixing $file, definition of statsswtch
554   sed -e 's/boottime$/boottime;/' ${LIB}/$file > ${LIB}/${file}.sed
555   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
556   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
557     rm ${LIB}/$file
558   fi
559 fi
560
561 # Fix an error in this file: a missing semi-colon at the end of the nodeent
562 # structure definition.
563 file=netdnet/dnetdb.h
564 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
565   mkdir ${LIB}/netdnet 2>/dev/null
566   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
567   chmod +w ${LIB}/$file 2>/dev/null
568   chmod a+r ${LIB}/$file 2>/dev/null
569 fi
570
571 if [ -r ${LIB}/$file ]; then
572   echo Fixing $file, definition of nodeent
573   sed -e 's/char.*na_addr *$/char *na_addr;/' ${LIB}/$file > ${LIB}/${file}.sed
574   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
575   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
576     rm ${LIB}/$file
577   fi
578 fi
579
580 # Check for bad #ifdef line (in Ultrix 4.1)
581 file=sys/file.h
582 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
583   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
584   chmod +w ${LIB}/$file 2>/dev/null
585   chmod a+r ${LIB}/$file 2>/dev/null
586 fi
587
588 if [ -r ${LIB}/$file ]; then
589   echo Fixing $file, bad \#ifdef line
590   sed -e 's/#ifdef KERNEL/#if defined(KERNEL)/' ${LIB}/$file > ${LIB}/${file}.sed
591   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
592   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
593     rm ${LIB}/$file
594   fi
595 fi
596
597 # Check for superfluous `static' (in Ultrix 4.2)
598 file=machine/cpu.h
599 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
600   mkdir ${LIB}/machine 2>/dev/null
601   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
602   chmod +w ${LIB}/$file 2>/dev/null
603   chmod a+r ${LIB}/$file 2>/dev/null
604 fi
605
606 if [ -r ${LIB}/$file ]; then
607   echo Fixing $file, superfluous static
608   sed -e 's/^static struct tlb_pid_state/struct tlb_pid_state/' ${LIB}/$file > ${LIB}/${file}.sed
609   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
610   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
611     rm ${LIB}/$file
612   else
613 # This file has an alternative name, mips/cpu.h.  Fix that name, too.
614     if cmp machine/cpu.h mips/cpu.h > /dev/null 2>&1; then
615       mkdir ${LIB}/mips 2>&-
616       ln ${LIB}/$file ${LIB}/mips/cpu.h 
617     fi
618   fi
619 fi
620
621 # Incorrect sprintf declaration in X11/Xmu.h
622 file=X11/Xmu.h
623 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
624   mkdir ${LIB}/X11 2>/dev/null
625   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
626   chmod +w ${LIB}/$file 2>/dev/null
627   chmod a+r ${LIB}/$file 2>/dev/null
628 fi
629
630 if [ -r ${LIB}/$file ]; then
631   echo Fixing $file sprintf declaration
632   sed -e 's,^extern char \*     sprintf();$,#ifndef __STDC__\
633 extern char *   sprintf();\
634 #endif /* !defined __STDC__ */,' ${LIB}/$file > ${LIB}/${file}.sed
635   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
636   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
637     rm ${LIB}/$file
638   fi
639 fi
640
641 # Incorrect sprintf declaration in X11/Xmu/Xmu.h
642 # (It's not clear whether the right file name is this or X11/Xmu.h.)
643 file=X11/Xmu/Xmu.h
644 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
645   mkdir ${LIB}/X11/Xmu 2>/dev/null
646   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
647   chmod +w ${LIB}/$file 2>/dev/null
648   chmod a+r ${LIB}/$file 2>/dev/null
649 fi
650
651 if [ -r ${LIB}/$file ]; then
652   echo Fixing $file sprintf declaration
653   sed -e 's,^extern char \*     sprintf();$,#ifndef __STDC__\
654 extern char *   sprintf();\
655 #endif /* !defined __STDC__ */,' ${LIB}/$file > ${LIB}/${file}.sed
656   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
657   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
658     rm ${LIB}/$file
659   fi
660 fi
661
662 # Check for missing ';' in struct
663 file=netinet/ip.h
664 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
665   mkdir ${LIB}/netinet 2>/dev/null
666   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
667   chmod +w ${LIB}/$file 2>/dev/null
668   chmod a+r ${LIB}/$file 2>/dev/null
669 fi
670
671 if [ -r ${LIB}/$file ]; then
672   echo Fixing $file
673   sed -e '/^struct/,/^};/s/}$/};/' ${LIB}/$file > ${LIB}/${file}.sed
674   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
675   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
676     rm -f ${LIB}/$file
677   fi
678 fi
679
680 # Fix the CAT macro in SunOS memvar.h.
681 file=pixrect/memvar.h
682 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
683   mkdir ${LIB}/pixrect 2>/dev/null
684   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
685   chmod +w ${LIB}/$file 2>/dev/null
686   chmod a+r ${LIB}/$file 2>/dev/null
687 fi
688
689 if [ -r ${LIB}/$file ]; then
690   echo Fixing $file
691   sed -e '/^#define.CAT(a,b)/ i\
692 #ifdef __STDC__ \
693 #define CAT(a,b) a##b\
694 #else
695 /^#define.CAT(a,b)/ a\
696 #endif
697 ' ${LIB}/$file > ${LIB}/${file}.sed
698   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
699   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
700     rm -f ${LIB}/$file
701   fi
702 fi
703
704 # Check for yet more missing ';' in struct (in SunOS 4.0.x)
705 file=rpcsvc/rusers.h
706 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
707   mkdir ${LIB}/rpcsvc 2>/dev/null
708   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
709   chmod +w ${LIB}/$file 2>/dev/null
710   chmod a+r ${LIB}/$file 2>/dev/null
711 fi
712
713 if [ -r ${LIB}/$file ]; then
714   echo Fixing $file
715   sed -e '/^struct/,/^};/s/_cnt$/_cnt;/' ${LIB}/$file > ${LIB}/${file}.sed
716   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
717   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
718     rm -f ${LIB}/$file
719   fi
720 fi
721
722 # Fix return type of exit and abort in <stdlib.h> on SunOS 4.1.
723 # Also wrap protection around size_t for m88k-sysv3 systems.
724 file=stdlib.h
725 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
726   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
727   chmod +w ${LIB}/$file 2>/dev/null
728   chmod a+r ${LIB}/$file 2>/dev/null
729 fi
730
731 if [ -r ${LIB}/$file ]; then
732   echo Fixing $file
733   sed -e 's/int abort/void      abort/g' \
734   -e 's/int     free/void       free/g' \
735   -e 's/char \* calloc/void \*  calloc/g' \
736   -e 's/char \* malloc/void \*  malloc/g' \
737   -e 's/char \* realloc/void \* realloc/g' \
738   -e 's/int     exit/void       exit/g' \
739   -e '/typedef[         a-zA-Z_]*[      ]size_t[        ]*;/i\
740 #ifndef _GCC_SIZE_T\
741 #define _GCC_SIZE_T' \
742   -e '/typedef[         a-zA-Z_]*[      ]size_t[        ]*;/a\
743 #endif' \
744       ${LIB}/$file > ${LIB}/${file}.sed
745   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
746   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
747     rm -f ${LIB}/$file
748   fi
749 fi
750
751 # Fix return type of free and {c,m,re}alloc in <malloc.h> on SunOS 4.1.
752 file=malloc.h
753 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
754   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
755   chmod +w ${LIB}/$file 2>/dev/null
756   chmod a+r ${LIB}/$file 2>/dev/null
757 fi
758
759 if [ -r ${LIB}/$file ]; then
760   echo Fixing $file
761   sed -e 's/typedef[    ]char \*        malloc_t/typedef void \*        malloc_t/g' \
762   -e 's/int[    ][      ]*free/void     free/g' \
763   ${LIB}/$file > ${LIB}/${file}.sed
764   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
765   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
766     rm -f ${LIB}/$file
767   fi
768 fi
769
770 # Fix bogus #ifdef in <hsfs/hsfs_spec.h> on SunOS 4.1.
771 file=hsfs/hsfs_spec.h
772 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
773   mkdir ${LIB}/hsfs 2>/dev/null
774   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
775   chmod +w ${LIB}/$file 2>/dev/null
776   chmod a+r ${LIB}/$file 2>/dev/null
777 fi
778
779 if [ -r ${LIB}/$file ]; then
780   echo Fixing $file
781   sed -e 's/\#ifdef __i386__ || __vax__/\#if __i386__ || __vax__/g' \
782     ${LIB}/$file > ${LIB}/${file}.
783   rm -f ${LIB}/$file; mv ${LIB}/${file}. ${LIB}/$file
784   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
785     rm -f ${LIB}/$file
786   fi
787 fi
788
789 # Fix bogus #ifdef in <hsfs/hsnode.h> on SunOS 4.1.
790 file=hsfs/hsnode.h
791 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
792   mkdir ${LIB}/hsfs 2>/dev/null
793   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
794   chmod +w ${LIB}/$file 2>/dev/null
795   chmod a+r ${LIB}/$file 2>/dev/null
796 fi
797
798 if [ -r ${LIB}/$file ]; then
799   echo Fixing $file
800   sed -e 's/\#ifdef __i386__ || __sun4c__/\#if __i386__ || __sun4c__/g' \
801     ${LIB}/$file > ${LIB}/${file}.sed
802   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
803   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
804     rm -f ${LIB}/$file
805   fi
806 fi
807
808 # Fix bogus #ifdef in <hsfs/iso_spec.h> on SunOS 4.1.
809 file=hsfs/iso_spec.h
810 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
811   mkdir ${LIB}/hsfs 2>/dev/null
812   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
813   chmod +w ${LIB}/$file 2>/dev/null
814   chmod a+r ${LIB}/$file 2>/dev/null
815 fi
816
817 if [ -r ${LIB}/$file ]; then
818   echo Fixing $file
819   sed -e 's/\#ifdef __i386__ || __vax__/\#if __i386__ || __vax__/g' \
820     ${LIB}/$file > ${LIB}/${file}.sed
821   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
822   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
823     rm -f ${LIB}/$file
824   fi
825 fi
826
827 # Incorrect #include in Sony News-OS 3.2.
828 file=machine/machparam.h
829 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
830   mkdir ${LIB}/machine 2>/dev/null
831   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
832   chmod +w ${LIB}/$file 2>/dev/null
833   chmod a+r ${LIB}/$file 2>/dev/null
834 fi
835
836 if [ -r ${LIB}/$file ]; then
837   echo Fixing $file, incorrect \#include
838   sed -e 's@"../machine/endian.h"@<machine/endian.h>@' \
839     ${LIB}/$file > ${LIB}/${file}.
840   rm -f ${LIB}/$file; mv ${LIB}/${file}. ${LIB}/$file
841   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
842     rm -f ${LIB}/$file
843   fi
844 fi
845
846 # Multiline comment after typedef on IRIX 4.0.1.
847 file=sys/types.h
848 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
849   mkdir ${LIB}/sys 2>/dev/null
850   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
851   chmod +w ${LIB}/$file 2>/dev/null
852   chmod a+r ${LIB}/$file 2>/dev/null
853 fi
854
855 if [ -r ${LIB}/$file ]; then
856   echo Fixing $file, comment in the middle of \#ifdef
857   sed -e 's@type of the result@type of the result */@' \
858     -e 's@of the sizeof@/* of the sizeof@' \
859     ${LIB}/$file > ${LIB}/${file}.sed
860   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
861   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
862     rm -f ${LIB}/$file
863   fi
864 fi
865
866 # Turning // comments into /* */ comments trashes this IRIX 4.0.1
867 # header file, which embeds // comments inside multi-line /* */
868 # comments.  If this looks like the IRIX header file, we refix it by
869 # just throwing away the // comments.
870 file=fam.h
871 if [ -r ${LIB}/$file ]; then
872   if egrep indigo.esd ${LIB}/$file > /dev/null; then
873     echo Fixing $file, overeager sed script
874     rm ${LIB}/$file
875     sed -e 's|//.*$||g' $file > ${LIB}/$file
876     chmod +w ${LIB}/$file 2>/dev/null
877     chmod a+r ${LIB}/$file 2>/dev/null
878   fi
879 fi
880
881 # Another IRIX 4.0.1 header file contains the string "//"
882 file=elf_abi.h
883 if [ -r ${LIB}/$file ]; then
884   echo Fixing $file, overeager sed script
885   sed -e 's|"/\*"\*/|"//"|' ${LIB}/$file > ${LIB}/${file}.sed
886   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
887   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
888     rm -f ${LIB}/$file
889   fi
890 fi
891
892 # Same problem with a file from SunOS 4.1.3 : a header file containing
893 # the string "//" embedded in "/**/"
894 file=sbusdev/audiovar.h
895 if [ -r ${LIB}/$file ]; then
896   echo Fixing $file, overeager sed script
897   rm ${LIB}/$file
898   sed -e 's|//.*$||g' $file > ${LIB}/$file
899   chmod +w ${LIB}/$file 2>/dev/null
900   chmod a+r ${LIB}/$file 2>/dev/null
901 fi
902
903 # Fix non-ANSI memcpy declaration that conflicts with gcc's builtin
904 # declaration on Sun OS 4.x.  We must only fix this on Sun OS 4.x, because
905 # many other systems have similar text but correct versions of the file.
906 # To ensure only Sun's is fixed, we grep for a likely unique string.
907 file=memory.h
908 if [ -r $file ] && egrep '/\*   @\(#\)memory\.h 1\.[2-4] 8./../.. SMI; from S5R2 1\.2   \*/' $file > /dev/null; then
909   if [ ! -r ${LIB}/$file ]; then
910     cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
911     chmod +w ${LIB}/$file 2>/dev/null
912     chmod a+r ${LIB}/$file 2>/dev/null
913   fi
914   if [ -r ${LIB}/$file ]; then
915     echo Replacing $file
916     cat > ${LIB}/$file << EOF
917 /* This file was generated by fixincludes */
918 #ifndef __memory_h__
919 #define __memory_h__
920
921 #ifdef __STDC__
922 extern void *memccpy();
923 extern void *memchr();
924 extern void *memcpy();
925 extern void *memset();
926 #else
927 extern char *memccpy();
928 extern char *memchr();
929 extern char *memcpy();
930 extern char *memset();
931 #endif /* __STDC__ */
932
933 extern int memcmp();
934
935 #endif /* __memory_h__ */
936 EOF
937   fi
938 fi
939
940 # parameters not const on DECstation Ultrix V4.0.
941 file=stdio.h
942 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
943   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
944   chmod +w ${LIB}/$file 2>/dev/null
945   chmod a+r ${LIB}/$file 2>/dev/null
946 fi
947
948 if [ -r ${LIB}/$file ]; then
949   echo Fixing $file, non-const arg
950   sed -e 's@perror( char \*__s );@perror( const char *__s );@' \
951       -e 's@fputs( char \*__s,@fputs( const char *__s,@' \
952       -e 's@fopen( char \*__filename, char \*__type );@fopen( const char *__filename, const char *__type );@' \
953       -e 's@fwrite( void \*__ptr,@fwrite( const void *__ptr,@' \
954       -e 's@fscanf( FILE \*__stream, char \*__format,@fscanf( FILE *__stream, const char *__format,@' \
955       -e 's@scanf( char \*__format,@scanf( const char *__format,@' \
956       -e 's@sscanf( char \*__s, char \*__format,@sscanf( const char *__s, const char *__format,@' \
957     ${LIB}/$file > ${LIB}/${file}.sed
958   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
959   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
960     rm -f ${LIB}/$file
961   fi
962 fi
963
964 # parameters conflict with C++ new on rs/6000 
965 for file in stdio.h unistd.h ; do
966   if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
967     cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
968     chmod +w ${LIB}/$file 2>/dev/null
969   fi
970
971   if [ -r ${LIB}/$file ]; then
972     echo Fixing $file, parameter name conflicts
973     sed -e 's@rename(const char \*old, const char \*new)@rename(const char *_old, const char *_new)@' \
974       ${LIB}/$file > ${LIB}/${file}.sed
975     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
976     if cmp $file ${LIB}/$file >/dev/null 2>&1; then
977       rm -f ${LIB}/$file
978     fi
979   fi
980 done
981
982 # function class(double x) conflicts with C++ keyword on rs/6000 
983 file=math.h
984 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
985   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
986   chmod +w ${LIB}/$file 2>/dev/null
987   chmod a+r ${LIB}/$file 2>/dev/null
988 fi
989
990 if [ -r ${LIB}/$file ]; then
991   if grep 'class[(]' ${LIB}/$file >/dev/null; then
992     echo Fixing $file
993     sed -e '/class[(]/i\
994 #ifndef __cplusplus' \
995         -e '/class[(]/a\
996 #endif' ${LIB}/$file > ${LIB}/${file}.sed
997     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
998     if cmp $file ${LIB}/$file >/dev/null 2>&1; then
999       rm ${LIB}/$file
1000     fi
1001   fi
1002 fi
1003
1004 # NeXT defines 'int wait(union wait*)', which conflicts with Posix.1.
1005 file=sys/wait.h
1006 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1007   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
1008   chmod +w ${LIB}/$file 2>/dev/null
1009 fi
1010
1011 if [ -r ${LIB}/$file ] \
1012   && grep 'wait[(]union wait' ${LIB}/$file >/dev/null; then
1013   echo Fixing $file, bad wait formal
1014   sed -e 's@wait(union wait@wait(void@' ${LIB}/$file > ${LIB}/${file}.sed
1015   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1016   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1017     rm -f ${LIB}/$file
1018   fi
1019 fi
1020
1021 # Don't use or define the name va_list in stdio.h.
1022 # This is for ANSI and also to interoperate properly with gvarargs.h.
1023 file=stdio.h
1024 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1025   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
1026   chmod +w ${LIB}/$file 2>/dev/null
1027   chmod a+r ${LIB}/$file 2>/dev/null
1028 fi
1029
1030 if [ -r ${LIB}/$file ]; then
1031   echo Fixing $file, use of va_list
1032   # Arrange for stdio.h to use stdarg.h to define __gnuc_va_list
1033   (echo "#define __need___va_list"
1034    echo "#include <stdarg.h>") > ${LIB}/${file}.sed
1035   # Use __gnuc_va_list in arg types in place of va_list.
1036   # On 386BSD use __gnuc_va_list instead of _VA_LIST_. We're hoping the
1037   # trailing parentheses and semicolon save all other systems from this.
1038   # Define __va_list__ (something harmless and unused) instead of va_list.
1039   # Don't claim to have defined va_list.
1040   sed -e 's@ va_list @ __gnuc_va_list @' \
1041       -e 's@ va_list)@ __gnuc_va_list)@' \
1042       -e 's@ _VA_LIST_));@ __gnuc_va_list));@' \
1043       -e 's@ va_list@ __va_list__@' \
1044       -e 's@\*va_list@*__va_list__@' \
1045       -e 's@_NEED___VA_LIST@_NEED___Va_LIST@' \
1046       -e 's@VA_LIST@DUMMY_VA_LIST@' \
1047       -e 's@_NEED___Va_LIST@_NEED___VA_LIST@' \
1048     ${LIB}/$file >> ${LIB}/${file}.sed
1049   
1050   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1051   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1052     rm -f ${LIB}/$file
1053   fi
1054 fi
1055
1056 # Cancel out ansi_compat.h on Ultrix.  Replace it with empty file.
1057 file=ansi_compat.h
1058 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1059   if grep -s ULTRIX $file; then
1060     echo "/* This file intentionally left blank.  */" > $LIB/$file
1061   fi
1062 fi
1063
1064 # parameter to atof not const on DECstation Ultrix V4.0.
1065 # also get rid of bogus inline definitions in HP-UX 8.0
1066 file=math.h
1067 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1068   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
1069   chmod +w ${LIB}/$file 2>/dev/null
1070   chmod a+r ${LIB}/$file 2>/dev/null
1071 fi
1072
1073 if [ -r ${LIB}/$file ]; then
1074   echo Fixing $file, non-const arg
1075   sed -e 's@atof( char \*__nptr );@atof( const char *__nptr );@' \
1076       -e 's@inline int abs(int d) { return (d>0)?d:-d; }@@' \
1077       -e 's@inline double abs(double d) { return fabs(d); }@@' \
1078     ${LIB}/$file > ${LIB}/${file}.sed
1079   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1080   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1081     rm -f ${LIB}/$file
1082   fi
1083 fi
1084
1085 # In limits.h, put #ifndefs around things that are supposed to be defined
1086 # in float.h to avoid redefinition errors if float.h is included first.
1087 # On HP/UX this patch does not work, because on HP/UX limits.h uses
1088 # multi line comments and the inserted #endif winds up inside the
1089 # comment.  Fortunately, HP/UX already uses #ifndefs in limits.h; if
1090 # we find a #ifndef FLT_MIN we assume that all the required #ifndefs
1091 # are there, and we do not add them ourselves.
1092 file=limits.h
1093 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1094   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
1095   chmod +w ${LIB}/$file 2>/dev/null
1096   chmod a+r ${LIB}/$file 2>/dev/null
1097 fi
1098
1099 if [ -r ${LIB}/$file ]; then
1100   if egrep 'ifndef[     ]+FLT_MIN' ${LIB}/$file >/dev/null; then
1101     true
1102   else
1103     echo Fixing $file
1104     sed -e '/[  ]FLT_MIN[       ]/i\
1105 #ifndef FLT_MIN'\
1106         -e '/[  ]FLT_MIN[       ]/a\
1107 #endif'\
1108         -e '/[  ]FLT_MAX[       ]/i\
1109 #ifndef FLT_MAX'\
1110         -e '/[  ]FLT_MAX[       ]/a\
1111 #endif'\
1112         -e '/[  ]FLT_DIG[       ]/i\
1113 #ifndef FLT_DIG'\
1114         -e '/[  ]FLT_DIG[       ]/a\
1115 #endif'\
1116         -e '/[  ]DBL_MIN[       ]/i\
1117 #ifndef DBL_MIN'\
1118         -e '/[  ]DBL_MIN[       ]/a\
1119 #endif'\
1120         -e '/[  ]DBL_MAX[       ]/i\
1121 #ifndef DBL_MAX'\
1122         -e '/[  ]DBL_MAX[       ]/a\
1123 #endif'\
1124         -e '/[  ]DBL_DIG[       ]/i\
1125 #ifndef DBL_DIG'\
1126         -e '/[  ]DBL_DIG[       ]/a\
1127 #endif'\
1128       ${LIB}/$file > ${LIB}/${file}.sed
1129     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1130   fi
1131   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1132     echo Deleting ${LIB}/$file\; no fixes were needed.
1133     rm -f ${LIB}/$file
1134   fi
1135 fi
1136
1137 # In math.h, put #ifndefs around things that might be defined in a gcc
1138 # specific math-*.h file.
1139 file=math.h
1140 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1141   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
1142   chmod +w ${LIB}/$file 2>/dev/null
1143   chmod a+r ${LIB}/$file 2>/dev/null
1144 fi
1145
1146 if [ -r ${LIB}/$file ]; then
1147   echo Fixing $file
1148   sed -e '/define[      ]HUGE_VAL[      ]/i\
1149 #ifndef HUGE_VAL'\
1150       -e '/define[      ]HUGE_VAL[      ]/a\
1151 #endif'\
1152     ${LIB}/$file > ${LIB}/${file}.sed
1153   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1154   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1155     echo Deleting ${LIB}/$file\; no fixes were needed.
1156     rm -f ${LIB}/$file
1157   fi
1158 fi
1159
1160 # Remove erroneous parentheses in sym.h on Alpha OSF/1.
1161 file=sym.h
1162 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1163   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
1164   chmod +w ${LIB}/$file 2>/dev/null
1165   chmod a+r ${LIB}/$file 2>/dev/null
1166 fi
1167
1168 if [ -r ${LIB}/$file ]; then
1169   echo Fixing $file
1170   sed -e 's/#ifndef(__mips64)/#ifndef __mips64/' \
1171     ${LIB}/$file > ${LIB}/${file}.sed
1172   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1173   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1174     rm -f ${LIB}/$file
1175   fi
1176 fi
1177
1178 # Fix incorrect S_IF* definitions on m88k-sysv3.
1179 file=sys/stat.h
1180 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1181   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
1182   chmod +w ${LIB}/$file 2>/dev/null
1183   chmod a+r ${LIB}/$file 2>/dev/null
1184 fi
1185
1186 if [ -r ${LIB}/$file ]; then
1187   echo Fixing $file
1188   sed -e 's/^\(#define[         ]*S_IS[A-Z]*(m)\)[      ]*(m[   ]*&[    ]*\(S_IF[A-Z][A-Z][A-Z][A-Z]*\)[        ]*)/\1 (((m)\&S_IFMT)==\2)/' \
1189       -e 's/^\(#define[         ]*S_IS[A-Z]*(m)\)[      ]*(m[   ]*&[    ]*\(0[0-9]*\)[  ]*)/\1 (((m)\&S_IFMT)==\2)/' \
1190     ${LIB}/$file > ${LIB}/${file}.sed
1191   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1192   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1193     rm -f ${LIB}/$file
1194   fi
1195 fi
1196
1197 # These two files on SunOS 4 are included by other files
1198 # in the same directory, using "...".  So we must make sure they exist
1199 # in the same directory as the other fixed files.
1200 if [ -r ${INPUT}/multimedia/audio_errno.h ]
1201 then
1202   ln -s ${INPUT}/multimedia/audio_errno.h ${LIB}/multimedia 2>/dev/null
1203 fi
1204 if [ -r ${INPUT}/multimedia/audio_hdr.h ]
1205 then
1206   ln -s ${INPUT}/multimedia/audio_hdr.h ${LIB}/multimedia 2>/dev/null
1207 fi
1208
1209 # Determine if we're on Interactive Unix 2.2 or later, in which case we
1210 # need to fix some additional files.  This is the same test for ISC that
1211 # Autoconf uses.
1212 if test -d /etc/conf/kconfig.d \
1213     && grep _POSIX_VERSION /usr/include/sys/unistd.h >/dev/null 2>&1; then
1214   echo "Fixing ISC __STDC__ goof in several files..."
1215   for name in stdio.h math.h ctype.h sys/limits.h sys/fcntl.h sys/dirent.h; do
1216     echo $name
1217     if test -r ${LIB}/$name; then
1218       file=${LIB}/$name
1219     else
1220       file=${INPUT}/$name
1221     fi
1222     # On Interactive 2.2, certain traditional Unix definitions
1223     # (notably getc and putc in stdio.h) are omitted if __STDC__ is
1224     # defined, not just if _POSIX_SOURCE is defined.  This makes it
1225     # impossible to compile any nontrivial program except with -posix.
1226     sed \
1227 's/!defined(__STDC__) && !defined(_POSIX_SOURCE)/!defined(_POSIX_SOURCE)/' \
1228             < $file > ${LIB}/$name.
1229     mv ${LIB}/$name. ${LIB}/$name
1230   done
1231   
1232   echo "Fixing ISC fmod declaration"
1233   # This one's already been fixed for other things.
1234   file=${LIB}/math.h
1235   sed 's/fmod(double)/fmod(double, double)/' <$file >$file.
1236   mv $file. $file
1237   
1238   echo "Fixing nested comments in ISC <sys/limits.h>"
1239   file=sys/limits.h
1240   sed '/CHILD_MAX/s,/\* Max, Max,' < ${INPUT}/$file >${LIB}/$file.
1241   sed '/OPEN_MAX/s,/\* Max, Max,' < ${LIB}/$file. >${LIB}/$file
1242 fi
1243
1244 # These files in Sun OS 4.x use /**/ to concatenate tokens.
1245 for file in sparc/asm_linkage.h sun3/asm_linkage.h sun3x/asm_linkage.h  \
1246         sun4/asm_linkage.h sun4c/asm_linkage.h sun4m/asm_linkage.h      \
1247         sun4c/debug/asm_linkage.h sun4m/debug/asm_linkage.h;
1248 do
1249   if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1250     cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
1251     chmod +w ${LIB}/$file 2>/dev/null
1252     chmod a+r ${LIB}/$file 2>/dev/null
1253   fi
1254
1255   if [ -r ${LIB}/$file ]; then
1256     sed -e 's|/\*\*/|##|g' ${LIB}/$file > ${LIB}/${file}.sed
1257     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1258     if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1259       rm -f ${LIB}/$file
1260     fi
1261   fi
1262 done
1263
1264 # These files in ARM/RISCiX use /**/ to concatenate tokens.
1265 for file in arm/as_support.h arm/mc_type.h arm/xcb.h dev/chardefmac.h \
1266         dev/ps_irq.h dev/screen.h dev/scsi.h sys/tty.h \
1267         X11/extensions/multibufst.h X11/Xmd.h X11/Xlibinit.h \
1268         Xm.acorn/XmP.h
1269 do
1270   if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1271     cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
1272     chmod +w ${LIB}/$file 2>/dev/null
1273     chmod a+r ${LIB}/$file 2>/dev/null
1274   fi
1275
1276   if [ -r ${LIB}/$file ]; then
1277     sed -e 's|/\*\*/|##|g' ${LIB}/$file > ${LIB}/${file}.sed
1278     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1279     if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1280       rm -f ${LIB}/$file
1281     fi
1282   fi
1283 done
1284
1285 echo 'Removing unneeded directories:'
1286 cd $LIB
1287 files=`find . -type d -print | sort -r`
1288 for file in $files; do
1289   rmdir $LIB/$file > /dev/null 2>&1
1290 done
1291
1292 if $LINKS; then
1293   echo 'Making internal symbolic non-directory links'
1294   cd ${INPUT}
1295   files=`find . -type l -print`
1296   for file in $files; do
1297     dest=`ls -ld $file | sed -n 's/.*-> //p'`
1298     if expr "$dest" : '[^/].*' > /dev/null; then    
1299       target=${LIB}/`echo file | sed "s|[^/]*\$|$dest|"`
1300       if [ -f $target ]; then
1301         ln -s $dest ${LIB}/$file >/dev/null 2>&1
1302       fi
1303     fi
1304   done
1305 fi
1306
1307 echo 'Cleaning up DONE files.'
1308 cd $LIB
1309 find . -name DONE -exec rm -f '{}' ';'
1310
1311 exit 0